routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});


Route::get('/admin', function() {
    return view('admin.index');
})->middleware('auth');

Route::prefix('admin')->group(function () {
    Route::get('/home', 'HomeController@index')->name('home');
    Route::resource('viagens', 'Admin\ViagemController')->middleware('auth');
    
   
    
});


Auth::routes();



Route::get('/home', function() {
    return view('home');
})->name('home')->middleware('auth');

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Viagem.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use App\User;
class Viagem extends Model
{
    //
    protected $table = 'viagens';
    protected $primaryKey = 'id';
    protected $fillable = [ 'users_id', 'veiculo', 'codatendimento', 'motorista', 
    'cobrador', 'inicioprogramado', 'iniciorealizado', 'fimprogramado','fimrealizado', 'data', 'codpontoinicio',
    'nomepontoinicio', 'codpontofim', 'nomepontofim','atividade', 'tabela', 'tipodia', 
    'toleranciaatrasosaida','toleranciaadiantamentosaida','toleranciaatrasochegada', 'toleranciaadiantamentochegada',
    'toleranciatempoviagem','eventos'];
    

    public function users() {
        return $this->belongsTo('App\User');
    }
}

app/Http/Controllers/Admin/ViagemController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Viagem;
use Illuminate\Http\Request;
use App\User;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Storage;

class ViagemController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $dados = Viagem::paginate(30);

        $numViagens = Viagem::count('id');    // obtém o número de registros

        return view('admin.viagens_list', ['linhas'=>$dados,'numViagens'=>$numViagens]);
       
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
       
        return view('admin.viagens_form', ['acao'=>1]);
        $users = User::orderBy('name')->get();
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
       
        $dados = $request->all();

        $inc = Viagem::create($dados);

        if ($inc) {
            return redirect()->route('viagens.index')
                 ->with('status', $request->nome . ' inserido com sucesso');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Viagem  $viagem
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
       
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Viagem  $viagem
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
        $reg = Viagem::find($id);
       
       

        return view('admin.viagens_form', ['reg' => $reg, 'acao' => 2]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Viagem  $viagem
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
          // obtém os dados do form
          $dados = $request->all();

          // posiciona no registo a ser alterado
          $reg = Viagem::find($id);
  
         
          // realiza a alteração
          $alt = $reg->update($dados);
  
          if ($alt) {
              return redirect()->route('viagens.index')
                              ->with('status', $request->numeroviagem . ' Alterado!');
          }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Viagem  $viagem
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $viagens = Viagem::find($id);
        if ($viagens->delete()) {
            return redirect()->route('viagens.index')
                            ->with('status', $viagens->nome . ' Excluído!');
        }
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
}

app/Http/Controllers/JSController.php
<?php

namespace App\Http\Controllers;

use App\Viagem;
use Illuminate\Http\Request;

class JSController extends Controller
{
    public function index()
    {
        //$viagens = Viagem::orderBy('id')->get();
        $viagens = Viagem::select('id as numeroviagem','veiculo', 'codatendimento', 'motorista', 
        'cobrador', 'inicioprogramado', 'iniciorealizado', 'fimprogramado','fimrealizado', 'data', 'codpontoinicio',
        'nomepontoinicio', 'codpontofim', 'nomepontofim','atividade', 'tabela', 'tipodia', 
        'toleranciaatrasosaida','toleranciaadiantamentosaida','toleranciaatrasochegada', 'toleranciaadiantamentochegada',
        'toleranciatempoviagem','eventos')->get();

        return response()
            ->json( ['viagens'=> $viagens] , 200, [], JSON_PRETTY_PRINT);
    }
    public function store(Request $request)
    {
        $dados = $request->all();
        $inc = Viagem::create($dados);
        if ($inc) {
            return response()->json([$inc], 201);
        } else {
            return response()->json(['error' => 'error_insert'], 500);
        }
    }
    public function show($id)
    {
        $reg = Viagem::find($id);
        if ($reg) {
            return response()
                ->json($reg, 200, [], JSON_PRETTY_PRINT);
        } else {
            return response()
                ->json(['error' => 'not_found'], 404);
        }
    }
    public function update(Request $request, $id)
    {
        $reg = Viagem::find($id);
        if ($reg) {
            $dados = $request->all();
            $alt = $reg->update($dados);
            if ($alt) {
                return response()
                    ->json($reg, 200, [], JSON_PRETTY_PRINT);
            } else {
                return response()
                    ->json(['error' => 'not_update'], 500);
            }
        } else {
            return response()
                ->json(['error' => 'not_found'], 404);
        }
    }
    public function destroy($id)
    {
        $reg = Viagem::find($id);
        if ($reg) {
            if ($reg->delete()) {
                return response()
                    ->json(['msg' => 'Ok! Excluído'], 200);
            } else {
                return response()
                    ->json(['error' => 'not_destroy'], 500);
            }
        } else {
            return response()
                ->json(['error' => 'not_found'], 404);
        }
    }
}

resources/views/admin/index.blade.php
@extends('adminlte::page')
@section('title', 'API VIAGENS')
@section('content_header')
    
@stop
@section('content')
    <H4>Bem-Vindo {{ Auth::user()->name }}!</h4>
    <p>Área de Administração VIAGENS</p>
@stop

resources/views/admin/viagens_form.blade.php
@extends('adminlte::page')

@section('title', 'Cadastro de Viagens')

@section('content_header')

@if ($acao==1)
<h2>Inclusão de Viagens
    @elseif ($acao ==2)
    <h2>Alteração de Viagens
        @endif

        <a href="{{ route('viagens.index') }}" class="btn btn-primary pull-right" role="button">Voltar</a>
    </h2>

    @endsection

    @section('content')

    <div class="container-fluid">

        @if ($acao==1)
        <form method="POST" action="{{ route('viagens.store') }}" enctype="multipart/form-data">
            @elseif ($acao==2)
            <form method="POST" action="{{route('viagens.update', $reg ?? ''->id)}}" enctype="multipart/form-data">
                {!! method_field('put') !!}
                @endif
                {{ csrf_field() }}

                <div class="row">
                    <div class="col-sm-1">
                        <div class="form-group">
                            <label for="veiculo">Veiculo</label>
                            <input type="text" id="veiculo" name="veiculo" required
                           
                            class="form-control">
                            
                        </div>
                    </div>
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="codatendimento">Cod. Atendimento</label>
                            <input type="text" id="codatendimento" name="codatendimento" required 
                           
                            class="form-control">
                        </div>
                    </div>

                    <div class="col-sm-4">
                        <div class="form-group">
                            <label for="motorista">Motorista</label>
                            <input type="text" id="motorista" name="motorista" required class="form-control">
                        </div>
                    </div>


                    <div class="col-sm-4">
                        <div class="form-group">
                            <label for="cobrador">Cobrador</label>
                            <input type="text" id="cobrador" name="cobrador" required 
                          
                            class="form-control">
                        </div>
                    </div>

                
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="inicioprogramado">Início Programado</label>
                            <input type="text" id="inicioprogramado" name="inicioprogramado" required
                                class="form-control">
                        </div>
                    </div>
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="iniciorealizado">Início Realizado</label>
                            <input type="text" id="iniciorealizado" name="iniciorealizado" required class="form-control">
                        </div>
                    </div>
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="fimprogramado">Final Programado</label>
                            <input type="text" id="fimprogramado" name="fimprogramado" required
                                class="form-control">
                        </div>
                    </div>
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="fimrealizado">Fim Realizado</label>
                            <input type="text" id="fimrealizado" name="fimrealizado" required class="form-control">
                        </div>
                    </div>


                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="data">Data</label>
                            <input type="text" id="data" name="data" required class="form-control">
                        </div>
                    </div>

                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="codpontoinicio">Cod. Ponto Início</label>
                            <input type="text" id="codpontoinicio" name="codpontoinicio" required class="form-control">
                        </div>
                    </div>
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="nomepontoinicio">Nome Ponto Início</label>
                            <input type="text" id="nomepontoinicio" name="nomepontoinicio" required
                                class="form-control">
                        </div>
                    </div>
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="codpontofim">Cod. Ponto Fim</label>
                            <input type="text" id="codpontofim" name="codpontofim" required class="form-control">
                        </div>
                    </div>
              
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="nomepontofim">Nome Ponto Fim</label>
                            <input type="text" id="nomepontofim" name="nomepontofim" required class="form-control">
                        </div>
                    </div>

                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="atividade">Atividade</label>
                            <input type="text" id="atividade" name="atividade" required class="form-control">
                        </div>
                    </div>


                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="tabela">Tabela</label>
                            <input type="text" id="tabela" name="tabela" required class="form-control">
                        </div>
                    </div>

                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="tipodia">Tipo Dia</label>
                            <input type="text" id="tipodia" name="tipodia" required class="form-control">
                        </div>
                    </div>
                   
                    <div class="col-sm-3">
                        <div class="form-group">
                            <label for="toleranciaatrasosaida">Tolerância Atraso Saída</label>
                            <input type="text" id="toleranciaatrasosaida" name="toleranciaatrasosaida" required
                                class="form-control">
                        </div>
                    </div>
                
                    <div class="col-sm-3">
                        <div class="form-group">
                            <label for="toleranciaadiantamentosaida">Tolerância Adiantamento Saída</label>
                            <input type="text" id="toleranciaadiantamentosaida" name="toleranciaadiantamentosaida"
                                required class="form-control">
                        </div>
                    </div>

                    <div class="col-sm-3">
                        <div class="form-group">
                            <label for="toleranciaatrasochegada">Tolerância Atraso Chegada</label>
                            <input type="text" id="toleranciaatrasochegada" name="toleranciaatrasochegada" required
                                class="form-control">
                        </div>
                    </div>


                    <div class="col-sm-3">
                        <div class="form-group">
                            <label for="toleranciaadiantamentochegada">Tolerância Adiantamento Chegada</label>
                            <input type="text" id="toleranciaadiantamentochegada" name="toleranciaadiantamentochegada"
                                required class="form-control">
                        </div>
                    </div>

                    <div class="col-sm-3">
                        <div class="form-group">
                            <label for="toleranciatempoviagem">Tolerância Tempo Viagem</label>
                            <input type="text" id="toleranciatempoviagem" name="toleranciatempoviagem" required
                                class="form-control">
                        </div>
                    </div>
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="eventos">Eventos</label>
                            <input type="text" id="eventos" name="eventos" required class="form-control">
                        </div>
                    </div>

                </div>
                
         
        </div>
      </div>

                <input type="submit" value="Enviar" class="btn btn-success">
                <input type="reset" value="Limpar" class="btn btn-warning">

            </form>
    </div>

    @endsection

    @section('js')
    <script src="https://code.jquery.com/jquery-latest.min.js"></script>
    <script src="/js/jquery.mask.min.js"></script>


    @endsection
    @section('content')

    @if ($errors->any())
    <div class="alert alert-danger">
        <ul>
            @foreach ($errors->all() as $error)
            <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
    @endif

resources/views/admin/viagens_list.blade.php
@extends('adminlte::page')

@section('title', 'Cadastro de Viagens')

@section('content_header')
    <h1>Cadastro de Viagens
    <a href="{{ route('viagens.create') }}" class="btn btn-primary pull-right"
       role="button">Novo</a>
    </h1>
@stop

@section('content')

@if (session('status'))
   <div class="alert alert-success">
      {{ session('status') }}
   </div> 
@endif

<table class="table-responsive table-striped table-bordered">
  <thead>
    <tr>
    <th>Número Viagem</th>
    <th>Cod. Usuário</th>
    <th>Veiculo</th>
      <th>Cod. Atendimento</th>
      <th>Motorista</th>
      <th>Cobrador</th>     
      <th>Inicio Programado</th>
      <th>Inicio Realizado</th>
      <th>Fim Realizado</th>
      <th>Data</th>
      <th>Cod. Ponto Inicio</th>
      <th>Nome Ponto Inicio</th>     
      <th>Cod. Ponto Fim</th>
      <th>Nome Ponto Fim</th>
      <th>Atividade</th>
      <th>Tabela</th>
      <th>TipoDia</th>     
      <th>Tolerância Atraso Saída</th>     
      <th>Tolerância Adiantamento Saída</th>     
      <th>Tolerância Atraso Chegada</th>     
      <th>Tolerância Adiantamento Chegada</th>     
      <th>Tolerância Tempo Viagem</th>     
      <th>Eventos</th>     
      <th>Ações</th>
    </tr>
  </thead>
  <tbody>
    @forelse ($linhas as $l)
      <tr>
        <td> {{$l->id}} </td>
        <td> {{$l->users_id}} </td>
        <td> {{$l->veiculo}} </td>
        <td> {{$l->codatendimento }} </td>
        <td> {{$l->motorista }} </td>
        <td> {{$l->cobrador}} </td>
        <td> {{$l->inicioprogramado}} </td>
        <td> {{$l->iniciorealizado}} </td>
        <td> {{$l->fimprogramado}} </td>
        <td> {{$l->fimrealizado}} </td>
        <td> {{$l->data}} </td>
        <td> {{$l->codpontoinicio}} </td>
        <td> {{$l->nomepontoinicio}} </td>
        <td> {{$l->codpontofim}} </td>
        <td> {{$l->nomepontofim}} </td>
        <td> {{$l->atividade}} </td>
        <td> {{$l->tabela}} </td>
        <td> {{$l->tipodia}} </td>
        <td> {{$l->toleranciaatrasosaida}} </td>
        <td> {{$l->toleranciaadiantamentosaida}} </td>
        <td> {{$l->toleranciaatrasochegada}} </td>
        <td> {{$l->toleranciaadiantamentochegada}} </td>
        <td> {{$l->toleranciatempoviagem}} </td>
        <td> {{$l->eventos}} </td>
        <td> 
            <a href="{{route('viagens.edit', $l->id)}}" 
                class="btn btn-warning btn-sm" title="Alterar"
                role="button"><i class="fa fa-edit"></i></a> &nbsp;&nbsp;
            <form style="display: inline-block"
                  method="post"
                  action="{{route('viagens.destroy', $l->id)}}"
                  onsubmit="return confirm('Confirma Exclusão?')">
                   {{method_field('delete')}}
                   {{csrf_field()}}
                  <button type="submit" title="Excluir"
                          class="btn btn-danger btn-sm"><i class="far fa-trash-alt"></i></button>
            </form>
        </td>
        @if ($loop->iteration == $loop->count)
             <tr><td colspan=8>Total de viagens cadastradas: {{$numViagens}}                              
                              </td></tr>
        @endif        
    @empty
      <tr><td colspan=8> Não há viagens cadastradas ou 
                         para o filtro informado </td></tr>
    @endforelse

  </tbody>
</table>  


@stop


@section('js')
  <script defer src="https://use.fontawesome.com/releases/v5.0.10/js/all.js" integrity="sha384-slN8GvtUJGnv6ca26v8EzVaR9DC58QEwsIk9q1QXdCU8Yu8ck/tL/5szYlBbqmS+" crossorigin="anonymous"></script>
@endsection

resources/views/home.blade.php
@extends('adminlte::page')

@section('title', 'AdminLTE')

@section('content_header')
    <h1 class="m-0 text-dark">API SIMULADOR</h1>
@stop

@section('content')
    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-body">
                    <p class="mb-0">Simulação da tabela viagem!</p>
                </div>
            </div>
        </div>
    </div>
@stop

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    {{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                            </li>
                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
</body>
</html>